import { QueryHandler } from '@nestjs/cqrs';
import { RedisConfigurationRepository } from '../../adapters/secondaries/redis-configuration.repository';
import { GetConfigurationQuery } from '../../queries/get-configuration.query';

@QueryHandler(GetConfigurationQuery)
export class GetConfigurationUseCase {
  constructor(private _configurationRepository: RedisConfigurationRepository) {}

  async execute(getConfigurationQuery: GetConfigurationQuery): Promise<string> {
    return this._configurationRepository.get(
      getConfigurationQuery.domain + ':' + getConfigurationQuery.key,
    );
  }
}
